
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class FulfillmentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const fulfillments = await db.fulfillments.create(
            {
                id: data.id || undefined,
        
        status: data.status
        ||
        null
            ,
            
        tracking_company: data.tracking_company
        ||
        null
            ,
            
        tracking_number: data.tracking_number
        ||
        null
            ,
            
        tracking_url: data.tracking_url
        ||
        null
            ,
            
        shipped_at: data.shipped_at
        ||
        null
            ,
            
        delivered_at: data.delivered_at
        ||
        null
            ,
            
        note: data.note
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await fulfillments.setOrder( data.order || null, {
            transaction,
        });
        
        await fulfillments.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return fulfillments;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const fulfillmentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                status: item.status
            ||
            null
            ,
            
                tracking_company: item.tracking_company
            ||
            null
            ,
            
                tracking_number: item.tracking_number
            ||
            null
            ,
            
                tracking_url: item.tracking_url
            ||
            null
            ,
            
                shipped_at: item.shipped_at
            ||
            null
            ,
            
                delivered_at: item.delivered_at
            ||
            null
            ,
            
                note: item.note
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const fulfillments = await db.fulfillments.bulkCreate(fulfillmentsData, { transaction });

        // For each item created, replace relation files
        

        return fulfillments;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const fulfillments = await db.fulfillments.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.tracking_company !== undefined) updatePayload.tracking_company = data.tracking_company;
        
        
        if (data.tracking_number !== undefined) updatePayload.tracking_number = data.tracking_number;
        
        
        if (data.tracking_url !== undefined) updatePayload.tracking_url = data.tracking_url;
        
        
        if (data.shipped_at !== undefined) updatePayload.shipped_at = data.shipped_at;
        
        
        if (data.delivered_at !== undefined) updatePayload.delivered_at = data.delivered_at;
        
        
        if (data.note !== undefined) updatePayload.note = data.note;
        
        
        updatePayload.updatedById = currentUser.id;

        await fulfillments.update(updatePayload, {transaction});

        
        
        if (data.order !== undefined) {
            await fulfillments.setOrder(
              
              data.order,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await fulfillments.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return fulfillments;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const fulfillments = await db.fulfillments.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of fulfillments) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of fulfillments) {
                await record.destroy({transaction});
            }
        });


        return fulfillments;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const fulfillments = await db.fulfillments.findByPk(id, options);

        await fulfillments.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await fulfillments.destroy({
            transaction
        });

        return fulfillments;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const fulfillments = await db.fulfillments.findOne(
            { where },
            { transaction },
        );

        if (!fulfillments) {
            return fulfillments;
        }

        const output = fulfillments.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.order = await fulfillments.getOrder({
            transaction
        });
        
        
        output.organizations = await fulfillments.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.orders,
        as: 'order',
        
        where: filter.order ? {
          [Op.or]: [
            { id: { [Op.in]: filter.order.split('|').map(term => Utils.uuid(term)) } },
            {
              order_number: {
                [Op.or]: filter.order.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.tracking_company) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'fulfillments',
                        'tracking_company',
                        filter.tracking_company,
                    ),
                };
            }
            
            if (filter.tracking_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'fulfillments',
                        'tracking_number',
                        filter.tracking_number,
                    ),
                };
            }
            
            if (filter.tracking_url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'fulfillments',
                        'tracking_url',
                        filter.tracking_url,
                    ),
                };
            }
            
            if (filter.note) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'fulfillments',
                        'note',
                        filter.note,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            shipped_at: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    delivered_at: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.shipped_atRange) {
                const [start, end] = filter.shipped_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    shipped_at: {
                    ...where.shipped_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    shipped_at: {
                    ...where.shipped_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.delivered_atRange) {
                const [start, end] = filter.delivered_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    delivered_at: {
                    ...where.delivered_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    delivered_at: {
                    ...where.delivered_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.fulfillments.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'fulfillments',
                        'tracking_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.fulfillments.findAll({
            attributes: [ 'id', 'tracking_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['tracking_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.tracking_number,
        }));
    }

    
};

